package org.gcube.portlets.widgets.ckancontentmoderator.client.events;

import org.gcube.datacatalogue.utillibrary.shared.ItemStatus;

import com.google.gwt.event.shared.GwtEvent;


/**
 * The Class SelectItemsWithItemStausEvent.
 *
 * @author Francesco Mangiacrapa at ISTI-CNR francesco.mangiacrapa@isti.cnr.it
 * 
 * Jun 25, 2021
 */
public class SelectItemsWithItemStausEvent extends GwtEvent<SelectItemsWithItemStausEventHandler> {
	public static Type<SelectItemsWithItemStausEventHandler> TYPE = new Type<SelectItemsWithItemStausEventHandler>();
	private ItemStatus itemStatus;

	/**
	 * Instantiates a new click item event.
	 *
	 * @param itemStatus the item status
	 */
	public SelectItemsWithItemStausEvent(ItemStatus itemStatus) {
		this.itemStatus = itemStatus;
	}

	/**
	 * Gets the associated type.
	 *
	 * @return the associated type
	 */
	@Override
	public Type<SelectItemsWithItemStausEventHandler> getAssociatedType() {
		return TYPE;
	}

	/**
	 * Dispatch.
	 *
	 * @param handler the handler
	 */
	@Override
	protected void dispatch(SelectItemsWithItemStausEventHandler handler) {
		handler.onValueChanged(this);
	}

	/**
	 * Gets the item status.
	 *
	 * @return the item status
	 */
	public ItemStatus getItemStatus() {
		return itemStatus;
	}

}
